local addon = MissionMinder:CreateAddon("MissionMinder")
local module = addon:CreateModule("autoLoot")

local function startLooting(missionComplete)
	local clickframe = missionComplete.BonusRewards.ChestModel.ClickFrame;
	GarrisonMissionCompleteChest_OnMouseDown(clickframe);
end


function MissionMinder_ExecuteAtAnimationStart(targetAnimIndex, func)
	local lastAnimIndex = nil;

	return function(self, elapsed)
		-- Keeps track of the resulting animIndex to determine when we finish one animation and begin another
		if ( lastAnimIndex ~= self.animIndex ) then
			lastAnimIndex = self.animIndex
			if (self.animIndex == targetAnimIndex) then
		 		func(self, elapsed)
			end
		end
	end
end

function MissionMinder_MissionComplete_StartAutoLooting(self, elapsed)
	if( MissionMinder.AutoLootRewards() and self.currentMission.succeeded) then
		startLooting(self);
	end
end

function MissionMinder_MissionFrame_AutoLootCompletedYetNotLootedMissions(self, missionList, index)
	if ( MissionMinder.AutoLootRewards() ) then
		local mission = missionList[index];
		if ( mission and mission.completed ) then
			startLooting(self.MissionComplete);
		end
	end
end

local ANIM_INDEX_REWARD_PANEL = 7;

function module.register(missionFrame)
	local missionComplete = missionFrame.MissionComplete

	-- Start autoloot on mission success
	hooksecurefunc(missionComplete, "OnUpdate", MissionMinder_ExecuteAtAnimationStart(ANIM_INDEX_REWARD_PANEL, MissionMinder_MissionComplete_StartAutoLooting));
	if(missionComplete:GetScript("OnUpdate")) then
		missionComplete:SetScript("OnUpdate", missionComplete.OnUpdate);
	end

	-- Start autoloot on mission complete frame initialize (if it's already received a MissionCompleteResponse, but has not been looted yet)
	hooksecurefunc(missionFrame, "MissionCompleteInitialize", MissionMinder_MissionFrame_AutoLootCompletedYetNotLootedMissions);
end
